package hu.uniobuda.nik.udp;

import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.UnknownHostException;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class UDPPeldaActivity extends Activity {

	EditText ip, msg;
	Button send;
	TextView myip, history;

	UDPServer udpServer;
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		// UI elemek elérése
		myip = (TextView)findViewById(R.id.myip);
		ip = (EditText) findViewById(R.id.ip);
		msg = (EditText) findViewById(R.id.msg);
		send = (Button) findViewById(R.id.send);
		history = (TextView) findViewById(R.id.history);

		this.udpServer = new UDPServer(Utils.getLocalIpInetAddress(), 54321);
		this.udpServer.setOnPacketReceive(new UDPServer.PacketReceiver() {
			public void onReceived(DatagramPacket packet) {

				final String inmsg = new String(packet.getData(), 0, packet
						.getLength());
				final String inip = packet.getAddress().getHostAddress();

				history.post(new Runnable() {
					public void run() {
						history.setText(inmsg + "\n" + history.getText());
						ip.setText(inip);
					}
				});

			}
		});
		this.udpServer.start();

		// Saját ip
		myip.setText(Utils.getLocalIpAddress());
		
		// Küldés
		send.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {

				try {
					InetAddress ipAddress = InetAddress.getByName(ip.getText()
							.toString());
					udpServer.sendMessage(msg.getText().toString(), ipAddress);
				} catch (UnknownHostException e) {
					e.printStackTrace();
				}

			}
		});

	}
	
	@Override
	protected void onDestroy() {
		udpServer.stopServer();
		super.onDestroy();
	}

	
}