package hu.uniobuda.nik.udp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;

public class UDPServer extends Thread {

	private InetAddress ip;
	private int port;
	private boolean run;
	
	private byte[] buffer;
	private DatagramSocket socket;
	private DatagramPacket packet;
	
	public UDPServer(InetAddress ip, int port) {
		this.port = port;
		this.ip = ip;		
		this.buffer = new byte[1024];
		this.packet = new DatagramPacket(buffer, buffer.length);
		try {
			this.socket = new DatagramSocket(port, ip);
		} catch (SocketException e) {
			e.printStackTrace();
		}
	}
	
	// Start ------
	@Override
	public void run() {
		this.run = true;
		if(socket != null){
			while(run){
				try {
					socket.receive(packet);
					if(onPacketReceive != null)
						onPacketReceive.onReceived(packet);
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}		
	}

	// Küld -------
	public void sendMessage(String msg, InetAddress ip) {
		byte[] msgByte = msg.getBytes();
		try {
			DatagramSocket socket = new DatagramSocket();
			socket.connect(ip, port);
			socket.send(new DatagramPacket(msgByte, msgByte.length, ip, port));
			socket.close();
		} catch (SocketException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	// Leállít ------
	public void stopServer() {
		this.run = false;
		this.socket.close();
	}
	
	// Getters -----------------
	public boolean isRun() {
		return run;
	}
	
	public InetAddress getIp() {
		return ip;
	}
	
	// Interfészek -------------
	interface PacketReceiver{
		void onReceived(DatagramPacket packet);
	}
	private PacketReceiver onPacketReceive;
	public void setOnPacketReceive(PacketReceiver onPacketReceive) {
		this.onPacketReceive = onPacketReceive;
	}
	
}
